## jbig2enc 0.30

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(jbig2enc CXX)
set(Version "0.30")

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

if(NOT CMAKE_BUILD_TYPE)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE
      Release
      CACHE STRING "Choose the type of build." FORCE)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release")
endif()

# ##############################################################################
# jbig2enc library
# ##############################################################################
add_definitions(-DVERSION="${Version}")

if(WIN32)
  set(LIBS ${LIBS} Ws2_32)
  if(MSVC)
    add_definitions(-DWIN32)
    add_definitions(-D_LIB)
    add_definitions(-D_CONSOLE)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    add_definitions(-D_SCL_SECURE_NO_WARNINGS)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MD")
    # turn off warnings in Release
    # C4267: '=': conversion from 'size_t' to 'int', possible loss of data
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /wd4267")
    # C4996: 'x': The POSIX name for this item is deprecated. Instead,
    # use the ISO C and C++ conformant name:
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /wd4996")
    # C4334: '<<': result of 32-bit shift implicitly converted to 64
    # bits (was 64-bit shift intended?)
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /wd4334")
    # C4244: 'x': conversion from 'a' to 'b', possible loss of data
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /wd4244")
    # C4305: 'initializing': truncation from 'double' to 'float'
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /wd4305")
    # Enable multiprocessor builds on Visual Studio
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
  endif()
else()
  set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O2 -DNDEBUG")
  set(CMAKE_CXX_FLAGS_DEBUG
      "${CMAKE_CXX_FLAGS_DEBUG} -DUNIFICATION_DEBUGGING -Wall -DDEBUG -pedantic -Og -g -noalign"
  )
endif()

if(NOT DEFINED CMAKE_DEBUG_POSTFIX)
  set(CMAKE_DEBUG_POSTFIX "d")
endif()

find_package(Leptonica REQUIRED)
message(STATUS "Found Leptonica library: ${Leptonica_VERSION}")
include_directories(${Leptonica_INCLUDE_DIRS})
link_directories(${Leptonica_LIBRARY_DIRS})

set(libjbig2enc_src
    "${CMAKE_CURRENT_SOURCE_DIR}/src/jbig2arith.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/jbig2comparator.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/jbig2enc.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/jbig2sym.cc")
set(libjbig2enc_hdr
    "${CMAKE_CURRENT_SOURCE_DIR}/src/jbig2arith.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/jbig2comparator.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/jbig2enc.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/jbig2segments.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/jbig2structs.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/jbig2sym.h")
add_library(libjbig2enc ${libjbig2enc_src} ${libjbig2enc_hdr})
set_target_properties(libjbig2enc PROPERTIES DEBUG_POSTFIX
                                             ${CMAKE_DEBUG_POSTFIX})

install(
  TARGETS libjbig2enc
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib)
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/src/jbig2enc.h" DESTINATION include/)
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/jbig2topdf.py" DESTINATION bin/)

# ##############################################################################
# Programs
# ##############################################################################

add_executable(jbig2 "${CMAKE_CURRENT_SOURCE_DIR}/src/jbig2.cc")
set_target_properties(jbig2 PROPERTIES DEBUG_POSTFIX ${CMAKE_DEBUG_POSTFIX})
target_link_libraries(jbig2 PRIVATE ${LIBS} libjbig2enc)
target_link_libraries(jbig2 PUBLIC ${Leptonica_LIBRARIES})
install(
  TARGETS jbig2
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib)

## jbig2enc 0.29

=== debian/changelog ===
jbig2enc (0.29-2.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:33:10 +0000

jbig2enc (0.29-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1064148

 -- Lukas Märdian <slyon@debian.org>  Wed, 28 Feb 2024 13:10:57 +0000

jbig2enc (0.29-2) unstable; urgency=medium

  * fix: set LD_LIBRARY_PATH when generating man page;
    closes: bug#1053203, thanks to Paul Wise

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 19 Oct 2023 19:51:55 +0200

jbig2enc (0.29-1) experimental; urgency=low

  * initial Release;
    closes: bug#1052276

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 19 Sep 2023 20:45:31 +0200

=== debian/control ===
Source: jbig2enc
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Jonas Smedegaard <dr@jones.dk>
Build-Depends: dpkg-dev (>= 1.22.5),
 cmark-gfm <!nodoc>,
 d-shlibs (>= 0.106~),
 debhelper-compat (= 13),
 help2man <!nodoc>,
 libgif-dev,
 libjpeg-dev,
 libleptonica-dev,
 libpng-dev,
 libtiff-dev,
 libwebp-dev,
 zlib1g-dev,
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/debian/jbig2enc.git
Vcs-Browser: https://salsa.debian.org/debian/jbig2enc
Homepage: https://github.com/agl/jbig2enc
Rules-Requires-Root: no

Package: libjbig2enc0t64
Provides: ${t64:Provides}
Replaces: libjbig2enc0
Conflicts: libjbig2enc0 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 link-grammar-dictionaries-en,
 minisat,
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 link-grammar-dictionaries-all,
Description: encoder for JBIG2 - libraries
 jbig2enc is an encoder for JBIG2.
 .
 JBIG2 encodes bi-level (1 bpp) images
 using a number of clever tricks to get better compression than G4.
 This encoder can:
  * Generate JBIG2 files, or fragments for embedding in PDFs
  * Generic region encoding
  * Perform symbol extraction, classification and text region coding
  * Perform refinement coding and,
  * Compress multipage documents
 .
 This package contains the shared library.

Package: libjbig2enc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libjbig2enc0t64 (= ${binary:Version}),
 ${devlibs:Depends},
 ${misc:Depends},
Description: encoder for JBIG2 - development headers
 jbig2enc is an encoder for JBIG2.
 .
 JBIG2 encodes bi-level (1 bpp) images
 using a number of clever tricks to get better compression than G4.
 This encoder can:
  * Generate JBIG2 files, or fragments for embedding in PDFs
  * Generic region encoding
  * Perform symbol extraction, classification and text region coding
  * Perform refinement coding and,
  * Compress multipage documents
 .
 This package contains the header files and static libraries

Package: jbig2
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: encoder for JBIG2 - command-line tool
 jbig2enc is an encoder for JBIG2.
 .
 JBIG2 encodes bi-level (1 bpp) images
 using a number of clever tricks to get better compression than G4.
 This encoder can:
  * Generate JBIG2 files, or fragments for embedding in PDFs
  * Generic region encoding
  * Perform symbol extraction, classification and text region coding
  * Perform refinement coding and,
  * Compress multipage documents
 .
 This package provides the command-line tool jbig2.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# generate documentation unless nodoc requested
DOCS_stem = README
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
DOCS = $(addsuffix .html,$(DOCS_stem)) $(addsuffix .txt,$(DOCS_stem))
MANPAGES = jbig2.1
endif

%:
	dh $@

%.html: %.md
	cmark-gfm $< > $@

%.txt: %.md
	cmark-gfm --to plaintext $< > $@

override_dh_autoreconf:
	dh_autoreconf --as-needed

override_dh_auto_configure:
	dh_auto_configure -- --disable-static --disable-rpath

execute_after_dh_auto_build: $(DOCS) $(MANPAGES)

execute_after_dh_auto_install:
	find debian/ -name "*.la" -delete
	d-shlibmove --commit \
		--t64 \
		--devunversioned \
		--exclude-la \
		--exclude-a \
		--multiarch \
		--movedev "debian/tmp/usr/include/*" usr/include/ \
		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/*.so

override_dh_install:
	dh_install -Xpdf.py

override_dh_installdocs:
	dh_installdocs --all -- $(DOCS)

override_dh_installchangelogs:
	dh_installchangelogs -- ChangeLog

# build manpages
jbig2.1: LD_LIBRARY_PATH = src/.libs
jbig2.1: %.1: src/%
	help2man --section 1 --no-info --no-discard-stderr \
		--name "encoder for JBIG2" \
		--output $@ $< \
		|| { $1 --help; false; }

## jbig2enc 0.30

=== debian/changelog ===
jbig2enc (0.30-1) unstable; urgency=medium

  [ upstream ]
  * new upstream release

  [ Jonas Smedegaard ]
  * drop patches cherry-picked upstream, now applied
  * update source helper script copyright-check
  * tighten build-dependency on d-shlibs

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 28 Dec 2024 02:44:38 +0100

jbig2enc (0.29-5) unstable; urgency=medium

  * add patch cherry-picked upstream
    to fix heap-use-after-free error;
    thanks to Jeff Breidenbach

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 29 Sep 2024 03:04:20 +0200

jbig2enc (0.29-4) unstable; urgency=medium

  * fix generate man page;
    closes: bug#1070220, thanks to Paul Wise and Bernhard Übelacker

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 17 Sep 2024 11:31:53 +0200

jbig2enc (0.29-3) unstable; urgency=medium

  * acknowledge NMU;
    thanks to Lukas Märdian
  * add patches cherry-picked upstream:
    + reject odd unsupported input depths
    + fix build with Leptonica >=1.83;
      closes: bug#1081968, thanks to Jeff Breidenbach
  * tighten build-dependency on d-shlibs
    (see bug#1081968)
  * update copyright info: update coverage
  * declare compliance with Debian Policy 4.7.0

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 17 Sep 2024 11:21:52 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: jbig2enc
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Jonas Smedegaard <dr@jones.dk>
-Build-Depends: dpkg-dev (>= 1.22.5),
+Maintainer: Jonas Smedegaard <dr@jones.dk>
+Build-Depends:
  cmark-gfm <!nodoc>,
- d-shlibs (>= 0.106~),
+ d-shlibs (>= 0.109~),
  debhelper-compat (= 13),
+ dpkg-dev (>= 1.22.5),
  help2man <!nodoc>,
  libgif-dev,
  libjpeg-dev,
@@ -15,16 +15,13 @@
  libtiff-dev,
  libwebp-dev,
  zlib1g-dev,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Git: https://salsa.debian.org/debian/jbig2enc.git
 Vcs-Browser: https://salsa.debian.org/debian/jbig2enc
 Homepage: https://github.com/agl/jbig2enc
 Rules-Requires-Root: no
 
 Package: libjbig2enc0t64
-Provides: ${t64:Provides}
-Replaces: libjbig2enc0
-Conflicts: libjbig2enc0 (<< ${source:Version})
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -35,6 +32,12 @@
  ${shlibs:Depends},
 Suggests:
  link-grammar-dictionaries-all,
+Provides:
+ ${t64:Provides},
+Replaces:
+ libjbig2enc0,
+Conflicts:
+ libjbig2enc0 (<< ${source:Version}),
 Description: encoder for JBIG2 - libraries
  jbig2enc is an encoder for JBIG2.
  .

=== debian/rules ===
--- 
+++ 
@@ -50,9 +50,8 @@
 	dh_installchangelogs -- ChangeLog
 
 # build manpages
-jbig2.1: LD_LIBRARY_PATH = src/.libs
 jbig2.1: %.1: src/%
-	help2man --section 1 --no-info --no-discard-stderr \
+	LD_LIBRARY_PATH=src/.libs help2man --section 1 --no-info --no-discard-stderr \
 		--name "encoder for JBIG2" \
 		--output $@ $< \
 		|| { $1 --help; false; }

=== debian/watch ===
version=4
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan

opts=\
filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-$1/ \
https://github.com/agl/jbig2enc/tags \
.*?@ANY_VERSION@@ARCHIVE_EXT@
